searchNodes=[{"doc":"Sax is an XML SAX parser and encoder.Sax provides functions to parse XML file in both binary and streaming way in compliant with Extensible Markup Language (XML) 1.0 (Fifth Edition).Sax also offers DSL and API to build, compose and encode XML document. See &quot;Encoder&quot; section below for more information.ParserSax parser supports two modes of parsing: SAX and simple form.SAX mode (Simple API for XML)SAX is an event driven algorithm for parsing XML documents. A SAX parser takes XML document as the input and emits events out to a pre-configured event handler during parsing.There are 5 types of SAX events supported by Sax::start_document - after prolog is parsed.:start_element - when open tag is parsed.:characters - when a chunk of CharData is parsed.:end_element - when end tag is parsed.:end_document - when the root element is closed.See Sax.Handler for more information.Simple form modeSax supports parsing XML documents into a simple format. See Sax.SimpleForm for more details.EncodingSax only supports UTF-8 encoding. It also respects the encoding set in XML document prolog, which means that if the declared encoding is not UTF-8, the parser stops. Anyway, when there is no encoding declared, Sax defaults the encoding to UTF-8.Reference expansionSax supports expanding character references and XML 1.0 predefined entity references, for example &amp;#65; is expanded to &quot;A&quot;, &amp;#x26; to &quot;&amp;&quot;, and &amp;amp; to &quot;&amp;&quot;.Sax does not expand external entity references, but provides an option to specify how they should be handled. See more in &quot;Shared options&quot; section.Creation of atomsSax does not create atoms during the parsing process.DTD and XSDSax does not support parsing DTD (Doctype Definition) and XSD schemas. When encountering DTD, the parser simply skips that.ConfigurationSax allows streaming feature to be configured off in compile time. This could give some performance gain when you use Sax to parse documents those are fully loaded in the memory.Note that this will make streaming feature not working. It's turned on by default.# config/config.exs config :sax, :parser, streaming: falseShared options:expand_entity - specifies how external entity references should be handled. Three supported strategies respectively are::keep - keep the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &amp;reg;&quot;, this is the default strategy.:skip - skip the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &quot;.{mod, fun, args} - take the applied result of the specified MFA.EncoderSax offers two APIs to build simple form and encode XML document.Use Sax.XML to build and compose XML simple form, then Sax.encode!/2 to encode the built element into XML binary.iex&gt; import Sax.XML iex&gt; element = element(&quot;person&quot;, [gender: &quot;female&quot;], &quot;Alice&quot;) {&quot;person&quot;, [{&quot;gender&quot;, &quot;female&quot;}], [{:characters, &quot;Alice&quot;}]} iex&gt; Sax.encode!(element, []) &quot;&lt;?xml version=\\&quot;1.0\\&quot;?&gt;&lt;person gender=\\&quot;female\\&quot;&gt;Alice&lt;/person&gt;&quot;See Sax.XML for more XML building APIs.Sax also provides Sax.Builder protocol to help composing structs into simple form.defmodule Person do @derive {Sax.Builder, name: &quot;person&quot;, attributes: [:gender], children: [:name]} defstruct [:gender, :name] end iex&gt; jack = %Person{gender: :male, name: &quot;Jack&quot;} iex&gt; john = %Person{gender: :male, name: &quot;John&quot;} iex&gt; import Sax.XML iex&gt; root = element(&quot;people&quot;, [], [jack, john]) iex&gt; Sax.encode!(root, []) &quot;&lt;?xml version=\\&quot;1.0\\&quot;?&gt;&lt;people&gt;&lt;person gender=\\&quot;male\\&quot;&gt;Jack&lt;/person&gt;&lt;person gender=\\&quot;male\\&quot;&gt;John&lt;/person&gt;&lt;/people&gt;&quot;","ref":"Sax.html","title":"Sax","type":"module"},{"doc":"Encodes a simple form XML element into string.This function encodes an element in simple form format and a prolog to an XML document.Examplesiex&gt; import Sax.XML iex&gt; root = element(:foo, [{&quot;foo&quot;, &quot;bar&quot;}], &quot;bar&quot;) iex&gt; prolog = [version: &quot;1.0&quot;] iex&gt; Sax.encode!(root, prolog) &quot;&lt;?xml version=\\&quot;1.0\\&quot;?&gt;&lt;foo foo=\\&quot;bar\\&quot;&gt;bar&lt;/foo&gt;&quot;","ref":"Sax.html#encode!/2","title":"Sax.encode!/2","type":"function"},{"doc":"Encodes a simple form element into IO data.Same as encode!/2 but this encodes the document into IO data.Examplesiex&gt; import Sax.XML iex&gt; root = element(:foo, [{&quot;foo&quot;, &quot;bar&quot;}], &quot;bar&quot;) iex&gt; prolog = [version: &quot;1.0&quot;] iex&gt; Sax.encode_to_iodata!(root, prolog) [ [&#39;&lt;?xml&#39;, [32, &#39;version&#39;, 61, 34, &quot;1.0&quot;, 34], [], [], &#39;?&gt;&#39;], [60, &quot;foo&quot;, 32, &quot;foo&quot;, 61, 34, &quot;bar&quot;, 34], 62, [&quot;bar&quot;], [60, 47, &quot;foo&quot;, 62] ]","ref":"Sax.html#encode_to_iodata!/2","title":"Sax.encode_to_iodata!/2","type":"function"},{"doc":"Parses XML stream data.This function takes a stream, SAX event handler (see more at Sax.Handler) and an initial state as the input, it returns {:ok, state} if parsing is successful, otherwise {:error, exception}, where exception is a Sax.ParseError struct which can be converted into readable message with Exception.message/1.Examplesdefmodule MyTestHandler do @behaviour Sax.Handler def handle_event(:start_document, prolog, state) do {:ok, [{:start_document, prolog} | state]} end def handle_event(:end_document, _data, state) do {:ok, [{:end_document} | state]} end def handle_event(:start_element, {name, attributes}, state) do {:ok, [{:start_element, name, attributes} | state]} end def handle_event(:end_element, name, state) do {:ok, [{:end_element, name} | state]} end def handle_event(:characters, chars, state) do {:ok, [{:chacters, chars} | state]} end end iex&gt; stream = File.stream!(&quot;./test/support/fixture/foo.xml&quot;) iex&gt; Sax.parse_stream(stream, MyTestHandler, []) {:ok, [{:end_document}, {:end_element, &quot;foo&quot;}, {:start_element, &quot;foo&quot;, [{&quot;bar&quot;, &quot;value&quot;}]}, {:start_document, [version: &quot;1.0&quot;]}]}Memory usageSax.parse_stream/3 takes a File.Stream or Stream as the input, so the amount of bytes to buffer in each chunk can be controlled by File.stream!/3 API.During parsing, the actual memory used by Sax might be higher than the number configured for each chunk, since Sax holds in memory some parsed parts of the original binary to leverage Erlang sub-binary extracting. Anyway, Sax tries to free those up when it makes sense.OptionsSee the “Shared options” section at the module documentation.","ref":"Sax.html#parse_stream/4","title":"Sax.parse_stream/4","type":"function"},{"doc":"Parses XML binary data.This function takes XML binary, SAX event handler (see more at Sax.Handler) and an initial state as the input, it returns {:ok, state} if parsing is successful, otherwise {:error, exception}, where exception is a Sax.ParseError struct which can be converted into readable message with Exception.message/1.The third argument state can be used to keep track of data and parsing progress when parsing is happening, which will be returned when parsing finishes.OptionsSee the “Shared options” section at the module documentation.Examplesdefmodule MyTestHandler do @behaviour Sax.Handler def handle_event(:start_document, prolog, state) do {:ok, [{:start_document, prolog} | state]} end def handle_event(:end_document, _data, state) do {:ok, [{:end_document} | state]} end def handle_event(:start_element, {name, attributes}, state) do {:ok, [{:start_element, name, attributes} | state]} end def handle_event(:end_element, name, state) do {:ok, [{:end_element, name} | state]} end def handle_event(:characters, chars, state) do {:ok, [{:chacters, chars} | state]} end end iex&gt; xml = &quot;&lt;?xml version=&#39;1.0&#39; ?&gt;&lt;foo bar=&#39;value&#39;&gt;&lt;/foo&gt;&quot; iex&gt; Sax.parse_string(xml, MyTestHandler, []) {:ok, [{:end_document}, {:end_element, &quot;foo&quot;}, {:start_element, &quot;foo&quot;, [{&quot;bar&quot;, &quot;value&quot;}]}, {:start_document, [version: &quot;1.0&quot;]}]}","ref":"Sax.html#parse_string/4","title":"Sax.parse_string/4","type":"function"},{"doc":"Protocol for building XML content.DerivingThis helps to generate XML content simple form in trivial cases.There are a few required options:name - tag name of generated XML element.attributes - fields to be encoded as attributes.children - fields to be encoded as element children.Examplesdefmodule Person do @derive {Sax.Builder, name: &quot;person&quot;, attributes: [:gender], children: [:name]} defstruct [:name, :gender] end iex&gt; person = %Person{name: &quot;Alice&quot;, gender: &quot;female&quot;} iex&gt; Sax.Builder.build(person) {&quot;person&quot;, [{&quot;gender&quot;, &quot;female&quot;}], [{:characters, &quot;Alice&quot;}]}Custom implementation could be done by implementing protocol:defmodule User do defstruct [:username, :name] end defimpl Sax.Builder do import Sax.XML def build(user) do element( &quot;Person&quot;, [{&quot;userName&quot;, user.username}], [element(&quot;Name&quot;, [], user.name)] ) end end iex&gt; user = %User{name: &quot;Alice&quot;, username: &quot;alice99&quot;} iex&gt; Sax.Builder.build(user) {&quot;Person&quot;, [{&quot;userName&quot;, &quot;alice99&quot;}], [{&quot;Name&quot;, [], [characters: &quot;Alice&quot;]}]}","ref":"Sax.Builder.html","title":"Sax.Builder","type":"protocol"},{"doc":"Builds content to XML content in simple form.","ref":"Sax.Builder.html#build/1","title":"Sax.Builder.build/1","type":"function"},{"doc":"","ref":"Sax.Builder.html#t:t/0","title":"Sax.Builder.t/0","type":"type"},{"doc":"This module provides callbacks to implement SAX events handler.","ref":"Sax.Handler.html","title":"Sax.Handler","type":"behaviour"},{"doc":"Callback for event handling.This callback takes an event type, an event data and user_state as the input.The initial user_state is the third argument in Sax.parse_string/3 and Sax.parse_stream/3. It can be accumulated and passed around during the parsing time by returning it as the result of the callback implementation, which can be used to keep track of data when parsing is happening.Returning {:ok, new_state} continues the parsing process with the new state.Returning {:stop, anything} stops the prosing process immediately, and anything will be returned. This feature is usually handy when we want to get the desired return without parsing the whole file.SAX EventsThere are a couple of events that need to be handled in the handler.:start_document.:start_element.:characters–the binary that matches CharData* and Reference. Note that it is not trimmed and includes ALL whitespace characters that match CharData.:end_document.:end_element.Check out event_data() type for more information of what are emitted for each event type.Examplesdefmodule MyEventHandler do @behaviour Sax.Handler def handle_event(:start_document, prolog, state) do {:ok, [{:start_document, prolog} | state]} end def handle_event(:end_document, _data, state) do {:ok, [{:end_document} | state]} end def handle_event(:start_element, {name, attributes}, state) do {:ok, [{:start_element, name, attributes} | state]} end def handle_event(:end_element, name, state) do {:ok, [{:end_element, name} | state]} end def handle_event(:characters, chars, state) do {:ok, [{:chacters, chars} | state]} end end","ref":"Sax.Handler.html#c:handle_event/3","title":"Sax.Handler.handle_event/3","type":"callback"},{"doc":"","ref":"Sax.Handler.html#t:characters_data/0","title":"Sax.Handler.characters_data/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:end_document_data/0","title":"Sax.Handler.end_document_data/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:end_element_data/0","title":"Sax.Handler.end_element_data/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:event_data/0","title":"Sax.Handler.event_data/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:event_name/0","title":"Sax.Handler.event_name/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:start_document_data/0","title":"Sax.Handler.start_document_data/0","type":"type"},{"doc":"","ref":"Sax.Handler.html#t:start_element_data/0","title":"Sax.Handler.start_element_data/0","type":"type"},{"doc":"Supports parsing an XML document partially. This module is useful when the XML document cannot be turned into a Stream e.g over sockets.Exampleiex&gt; {:ok, partial} = Sax.Partial.new(StackHandler, []) iex&gt; {:cont, partial} = Sax.Partial.parse(partial, &quot;&lt;foo&gt;&quot;) iex&gt; {:cont, partial} = Sax.Partial.parse(partial, &quot;&lt;/foo&gt;&quot;) iex&gt; Sax.Partial.terminate(partial) {:ok, [ end_document: {}, end_element: &quot;foo&quot;, start_element: {&quot;foo&quot;, []}, start_document: [] ]}","ref":"Sax.Partial.html","title":"Sax.Partial","type":"module"},{"doc":"Builds up a Sax.Partial, which can be used for later parsing.","ref":"Sax.Partial.html#new/3","title":"Sax.Partial.new/3","type":"function"},{"doc":"Continue parsing next chunk of the document with a partial.This function can return in 3 ways:{:cont, partial} - The parsing process has not been terminated.{:halt, user_state} - The parsing process has been terminated, usually because of fast return.{:error, exception} - The parsing process has erred.","ref":"Sax.Partial.html#parse/2","title":"Sax.Partial.parse/2","type":"function"},{"doc":"Terminates the XML document parsing.","ref":"Sax.Partial.html#terminate/1","title":"Sax.Partial.terminate/1","type":"function"},{"doc":"","ref":"Sax.Partial.html#t:t/0","title":"Sax.Partial.t/0","type":"opaque"},{"doc":"","ref":"Sax.Prolog.html","title":"Sax.Prolog","type":"module"},{"doc":"","ref":"Sax.Prolog.html#from_keyword/1","title":"Sax.Prolog.from_keyword/1","type":"function"},{"doc":"","ref":"Sax.Prolog.html#t:t/0","title":"Sax.Prolog.t/0","type":"type"},{"doc":"Provides functions to parse a XML document to simple-form data structure.Data structureSimple form is a basic representation of the parsed XML document. It contains a root element, and all elements are in the following format:element = {tag_name, attributes, content} content = (element | binary)*See &quot;Types&quot; section for more information.","ref":"Sax.SimpleForm.html","title":"Sax.SimpleForm","type":"module"},{"doc":"Parse given string into simple form.Options:expand_entity - specifies how external entity references should be handled. Three supported strategies respectively are::keep - keep the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &amp;reg;&quot;, this is the default strategy.:skip - skip the original binary, for example Orange &amp;reg; will be expanded to &quot;Orange &quot;.{mod, fun, args} - take the applied result of the specified MFA.ExamplesGiven this XML document.iex&gt; xml = &quot;&quot;&quot; ...&gt; &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot; ?&gt; ...&gt; &lt;menu&gt; ...&gt; &lt;movie url=&quot;https://www.imdb.com/title/tt0120338/&quot; id=&quot;tt0120338&quot;&gt; ...&gt; &lt;name&gt;Titanic&lt;/name&gt; ...&gt; &lt;characters&gt;Jack &amp;amp; Rose&lt;/characters&gt; ...&gt; &lt;/movie&gt; ...&gt; &lt;movie url=&quot;https://www.imdb.com/title/tt0109830/&quot; id=&quot;tt0109830&quot;&gt; ...&gt; &lt;name&gt;Forest Gump&lt;/name&gt; ...&gt; &lt;characters&gt;Forest &amp;amp; Jenny&lt;/characters&gt; ...&gt; &lt;/movie&gt; ...&gt; &lt;/menu&gt; ...&gt; &quot;&quot;&quot; iex&gt; Sax.SimpleForm.parse_string(xml) {:ok, {&quot;menu&quot;, [], [ &quot;\\n &quot;, { &quot;movie&quot;, [ {&quot;url&quot;, &quot;https://www.imdb.com/title/tt0120338/&quot;}, {&quot;id&quot;, &quot;tt0120338&quot;} ], [ &quot;\\n &quot;, {&quot;name&quot;, [], [&quot;Titanic&quot;]}, &quot;\\n &quot;, {&quot;characters&quot;, [], [&quot;Jack &amp; Rose&quot;]}, &quot;\\n &quot;] }, &quot;\\n &quot;, { &quot;movie&quot;, [ {&quot;url&quot;, &quot;https://www.imdb.com/title/tt0109830/&quot;}, {&quot;id&quot;, &quot;tt0109830&quot;} ], [ &quot;\\n &quot;, {&quot;name&quot;, [], [&quot;Forest Gump&quot;]}, &quot;\\n &quot;, {&quot;characters&quot;, [], [&quot;Forest &amp; Jenny&quot;]}, &quot;\\n &quot; ] }, &quot;\\n&quot; ]}}","ref":"Sax.SimpleForm.html#parse_string/2","title":"Sax.SimpleForm.parse_string/2","type":"function"},{"doc":"","ref":"Sax.SimpleForm.html#t:attributes/0","title":"Sax.SimpleForm.attributes/0","type":"type"},{"doc":"","ref":"Sax.SimpleForm.html#t:content/0","title":"Sax.SimpleForm.content/0","type":"type"},{"doc":"","ref":"Sax.SimpleForm.html#t:t/0","title":"Sax.SimpleForm.t/0","type":"type"},{"doc":"","ref":"Sax.SimpleForm.html#t:tag_name/0","title":"Sax.SimpleForm.tag_name/0","type":"type"},{"doc":"Helper functions for building XML elements.","ref":"Sax.XML.html","title":"Sax.XML","type":"module"},{"doc":"Builds CDATA in simple form.","ref":"Sax.XML.html#cdata/1","title":"Sax.XML.cdata/1","type":"function"},{"doc":"Builds characters in simple form.","ref":"Sax.XML.html#characters/1","title":"Sax.XML.characters/1","type":"function"},{"doc":"Builds comment in simple form.","ref":"Sax.XML.html#comment/1","title":"Sax.XML.comment/1","type":"function"},{"doc":"Builds element in simple form.","ref":"Sax.XML.html#element/3","title":"Sax.XML.element/3","type":"function"},{"doc":"Builds empty element in simple form.","ref":"Sax.XML.html#empty_element/2","title":"Sax.XML.empty_element/2","type":"function"},{"doc":"Builds processing instruction in simple form.","ref":"Sax.XML.html#processing_instruction/2","title":"Sax.XML.processing_instruction/2","type":"function"},{"doc":"Builds reference in simple form.","ref":"Sax.XML.html#reference/2","title":"Sax.XML.reference/2","type":"function"},{"doc":"","ref":"Sax.XML.html#t:cdata/0","title":"Sax.XML.cdata/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:characters/0","title":"Sax.XML.characters/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:comment/0","title":"Sax.XML.comment/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:content/0","title":"Sax.XML.content/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:dec_ref/0","title":"Sax.XML.dec_ref/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:element/0","title":"Sax.XML.element/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:entity_ref/0","title":"Sax.XML.entity_ref/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:hex_ref/0","title":"Sax.XML.hex_ref/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:processing_instruction/0","title":"Sax.XML.processing_instruction/0","type":"type"},{"doc":"","ref":"Sax.XML.html#t:ref/0","title":"Sax.XML.ref/0","type":"type"},{"doc":"Returned when parser encounters errors during parsing.","ref":"Sax.ParseError.html","title":"Sax.ParseError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Sax.ParseError.html#message/1","title":"Sax.ParseError.message/1","type":"function"},{"doc":"","ref":"Sax.ParseError.html#t:reason/0","title":"Sax.ParseError.reason/0","type":"type"},{"doc":"","ref":"Sax.ParseError.html#t:t/0","title":"Sax.ParseError.t/0","type":"type"}]